#include "object.h"
#include "objectinstance.h"
#include "instancescene.h"
#include "renderer.h"

#pragma GCC diagnostic ignored "-Wdeprecated-declarations"

namespace Msp {
namespace GL {

void InstanceScene::add(Renderable &r)
{
	renderables[r.get_instance_key()].insert(&r);
}

void InstanceScene::remove(Renderable &r)
{
	InstanceMap::iterator i = renderables.find(r.get_instance_key());
	if(i!=renderables.end())
	{
		i->second.erase(&r);
		if(i->second.empty())
			renderables.erase(i);
	}
}

void InstanceScene::setup_frame(Renderer &renderer)
{
	for(InstanceMap::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
		for(RenderableSet::const_iterator j=i->second.begin(); j!=i->second.end(); ++j)
			(*j)->setup_frame(renderer);
}

void InstanceScene::finish_frame()
{
	for(InstanceMap::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
		for(RenderableSet::const_iterator j=i->second.begin(); j!=i->second.end(); ++j)
			(*j)->finish_frame();
}

void InstanceScene::render(Renderer &renderer, Tag tag) const
{
	if(setup_frustum(renderer))
	{
		for(InstanceMap::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
			for(RenderableSet::const_iterator j=i->second.begin(); j!=i->second.end(); ++j)
				if(!frustum_cull(**j))
					renderer.render(**j, tag);
	}
	else
	{
		for(InstanceMap::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
			for(RenderableSet::const_iterator j=i->second.begin(); j!=i->second.end(); ++j)
				renderer.render(**j, tag);
	}
}

} // namespace GL
} // namespace Msp
